// Generated by CoffeeScript 1.12.7
(function() {
  var RedisLocker, _, locker, moment, unlocker;

  moment = require('moment');

  _ = require('lodash');

  RedisLocker = require('../models/redis-locker');

  locker = function(arg) {
    var redis, ref, reqPath, timestampPath, uuidPath;
    redis = arg.redis, reqPath = (ref = arg.reqPath) != null ? ref : 'body', uuidPath = arg.uuidPath, timestampPath = arg.timestampPath;
    return function(req, res, next) {
      var data, redisLocker, timestamp, uuid;
      data = _.get(req, reqPath);
      uuid = _.get(data, uuidPath);
      timestamp = _.get(data, timestampPath, moment.utc().format());
      redisLocker = new RedisLocker({
        uuid: uuid,
        timestamp: timestamp,
        redis: redis
      });
      return redisLocker.lockBlock((function(_this) {
        return function(error, lock) {
          if (error != null) {
            return res.sendStatus(error.code || 500);
          }
          req.lock = lock;
          return next();
        };
      })(this));
    };
  };

  unlocker = function() {
    return function(req, res, next) {
      if (req.lock == null) {
        return next();
      }
      return req.lock.unlock(function() {
        return next();
      });
    };
  };

  module.exports = {
    locker: locker,
    unlocker: unlocker
  };

}).call(this);

//# sourceMappingURL=redis-locker.js.map
